VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsGroups"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private DatabasePath As String
Private Groups() As New clsGrouping

Public Function Count() As Integer
On Error Resume Next
    Count = UBound(Groups)
End Function

Public Function Getgroups() As clsGrouping()
    Getgroups = Groups
End Function

Public Function GetByIndex(Index As Integer) As clsGrouping
On Error GoTo hErr:
    Set GetByIndex = Groups(Index)
    Exit Function
hErr:
    Set GetByIndex = New clsGrouping
End Function

Public Function GetByName(Username As String) As clsGrouping

    Dim I As Integer
    I = Find(Username)
    If I > -1 Then
        Set GetByName = Groups(I)
        Exit Function
    End If
    Dim Temp As New clsGrouping
    Temp.Groupname = "#INVALID#"
    Temp.Attributes = 0
    Set GetByName = Temp

End Function
Public Sub SetUser(Index As Integer, User As clsGrouping)
    Set Groups(Index) = User
End Sub

Private Function Same(Str1 As String, Str2 As String) As Boolean
    Same = LCase$(Str1) = LCase$(Str2)
End Function

Public Sub Clear()
    ReDim Groups(0)
End Sub

Public Sub Load(P As String)
    DatabasePath = P
    ReDim Groups(0)
    Dim FF As Integer, Content As String, Line As Long
    FF = FreeFile
    Open DatabasePath For Append As #FF
    Close #FF
    Open DatabasePath For Input As #FF
        Do Until EOF(FF) Or Err
            Line Input #FF, Content
            Line = Line + 1
            If InStrB(Content, "%") <> 0 Then
                Dim Data() As String, Out As String
                Data = Split(Content, "%")
                If UBound(Data) = 4 Then
                    If Not Add(Data(0), Data(1), Data(2), Data(3), Data(4), Out, False) Then
                        Debug.Print "Cannot add user at line: " & Line & " -- " & Out
                    End If
                Else
                    Debug.Print "Invalid user at line: " & Line
                End If
            End If
        Loop
    Close #FF
    Save
End Sub

Public Sub Save()
    Dim FF As Integer: FF = FreeFile
    Open DatabasePath For Append As #FF
    Close #FF
    Open DatabasePath For Output As #FF
        Dim I As Integer
        For I = 0 To UBound(Groups)
            Print #FF, Groups(I).Groupname & "%" & Groups(I).AttributeString & "%" & Groups(I).AddedTime & "%" & Groups(I).AddedDate & "%" & Groups(I).Addedby
        Next I
    Close #FF
End Sub

Public Function Add(Group As String, Attributes As String, _
     Optional AddTime As String, Optional AddDate As String, Optional AddBy As String, Optional Out As String, Optional DoSave As Boolean = True) As Boolean
    
    If Find(Group) > -1 Then: Out = "User already exists!": Exit Function
    If LenB(AddTime) = 0 Then AddTime = Time
    If LenB(AddDate) = 0 Then AddDate = Date
    If LenB(AddBy) = 0 Then AddBy = "[Knight]"
    If LenB(Group) = 0 Then AddBy = vbNullString
    
    Dim IU As New clsGrouping
    With IU
        .Groupname = Group
        .Attributes = StringToAttribute(Attributes)
        .Addedby = AddBy
        .AddedDate = AddDate
        .AddedTime = AddTime
    End With
    
    If LenB(Groups(0).Groupname) = 0 Then
        Set Groups(0) = IU
    Else
        ReDim Preserve Groups(UBound(Groups) + 1)
        Set Groups(UBound(Groups)) = IU
    End If

    Add = True
    If DoSave Then Save
End Function
Public Function Update(GroupIndex As Integer, Flags As String) As Boolean
        Dim I As Integer, Attributes As Long
        
        Attributes = StringToAttribute(Flags)
        
        Groups(GroupIndex).Attributes = Groups(GroupIndex).Attributes Xor Attributes
        Update = True
        Save
End Function
Public Function findPattern(ByVal User As String) As Integer
    If LenB(User) = 0 Then findPattern = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Groups) To 0 Step -1
        If User = LCase$(Groups(I).Groupname) Then
            findPattern = I
            Exit Function
        End If
    Next I
    findPattern = -1
End Function

Public Function Find(ByVal User As String) As Integer
    If LenB(User) = 0 Then Find = -2: Exit Function
    Dim I As Integer
    User = LCase$(User)
    For I = UBound(Groups) To 0 Step -1
        If User = LCase$(Groups(I).Groupname) Then
            Find = I
            Exit Function
        End If
    Next I
   ' For i = UBound(groups) To 0 Step -1
    '    If Matches(User, LCase$(groups(i).groupname)) Then
    '        If GetRankByID(groups(i).RankID).PatternMatch Then Find = i
    '        Exit Function
    '    End If
    'Next i
    Find = -1
End Function

Public Function matchUser(ByVal Match As String, ByRef Result() As Integer) As Boolean
    If LenB(Match) = 0 Then matchUser = False: Exit Function
    Dim I() As Integer, X As Integer
    ReDim I(0): I(0) = -1
    For X = UBound(Groups) To 0 Step -1
        If Matches(Groups(X).Groupname, Match) Then
            If I(0) = -1 Then
                I(0) = X
            Else
                ReDim Preserve I(UBound(I) + 1)
                I(UBound(I)) = X
            End If
        End If
    Next X
    If I(0) <> -1 Then matchUser = True
    Result = I
End Function

Public Function Remove(ByVal User As String) As Boolean
    Dim I As Integer, R As Integer
    User = LCase$(User)
    If UBound(Groups) = 0 Then
        If LCase$(Groups(0).Groupname) = User Then
            ReDim Groups(0)
            Remove = True
            Save
            Exit Function
        End If
    End If
    For I = 0 To UBound(Groups)
        If User = LCase$(Groups(I).Groupname) Then
            For R = I To UBound(Groups) - 1
                Set Groups(R) = Groups(R + 1)
            Next R
            ReDim Preserve Groups(UBound(Groups) - 1)
            Remove = True
            Save
            Exit Function
        End If
    Next I
    Exit Function
End Function
Private Sub Class_Initialize()
    ReDim Groups(0) As New clsGrouping
End Sub

Private Sub Class_Terminate()
    ReDim Groups(0)
End Sub

