Attribute VB_Name = "modFunctions"
Option Explicit
Public Sub LoadSettings()
    Username = Config.Username
    Password = Config.Password
    Channel = Config.Channel
    Client = Config.Client
    CDKey1 = Config.CDKey1
    CDKey2 = Config.CDKey2
    Server = Config.Server
    Trigger = Config.Trigger
    BNLSServer = Config.BNLSServer
    Email = Config.Email
    WardenCookie = GetTickCount
    
    If Profile = vbNullString Then
        frmMain.Caption = "Knight (" & Version & ")" & " on " & AddQuotes(Username & "@" & Server)
        Groups.Load App.Path & "\Groups.txt"
        Database.Load App.Path & "\Database.txt"
    Else
        frmMain.Caption = "Knight" & " (profile: " & Profile & ")"
        Groups.Load App.Path & "\Profiles\" & Profile & "\Groups.txt"
        Database.Load App.Path & "\Profiles\" & Profile & "\Database.txt"
    End If
     
    If LCase$(GetSetting("Bot", "Whisper responses")) = LCase$("on") Then
        Whisperback = True
    End If
    
    If LCase$(GetSetting("Features", "Shortvisit Ban")) = LCase$("on") Then
        ShortVisit = True
    End If
    
    ShortVisitTime = Config.ShortVisitTime
    FastJoinTime = Config.FastJoinTime
    LockdownMessage = Config.LockdownMessage
    Realm = Config.RealmName
    PingbanLimit = Config.PingbanLimit
    
    If LCase$(GetSetting("Features", "IPBan")) = LCase$("on") Then
        IPBan = True
    End If
    
    If LCase$(GetSetting("Features", "Lockdown")) = LCase$("on") Then
        Lockdown = True
    End If
    
    If LCase$(GetSetting("Features", "Fast join talk")) = LCase$("on") Then
        FastJoin = True
    End If
    
    If LCase$(GetSetting("Features", "Spamban")) = LCase$("on") Then
        Spamban = True
    End If
    
    If LCase$(GetSetting("Features", "Remote Channel")) = LCase$("on") Then
        RemoteChannel = True
    End If
    
    If LCase$(GetSetting("Features", "Pingban")) = LCase$("on") Then
        Pingban = True
    End If
    
    Select Case UCase(Client)
        Case "D2XP", "PX2D"
            ExpansionClient = True
            Warcraft3 = False
            WardenEnabled = False
            D2 = True
        Case "D2DV", "VD2D"
            D2 = True
        Case "W3XP", "PX3W"
            ExpansionClient = True
            WardenEnabled = True
            Warcraft3 = True
        Case "WAR3", "3RAW"
            ExpansionClient = False
            WardenEnabled = True
            Warcraft3 = True
        Case "STAR", "SEXP", "PXES", "RATS"
            WardenEnabled = True
            ExpansionClient = False
            Warcraft3 = False
        Case Else
            ExpansionClient = False
            Warcraft3 = False
            WardenEnabled = False
    End Select
End Sub
Public Function BNLSProductID() As Byte

    Select Case UCase(Client)
    
        Case "STAR", "RATS"
            BNLSProductID = &H1
            
        Case "SEXP", "PXES"
            BNLSProductID = &H2
        
        Case "D2DV", "VD2D"
            BNLSProductID = &H4
        
        Case "D2XP", "PX2D"
            BNLSProductID = &H5
        
        Case "W2BN", "BN2W"
            BNLSProductID = &H3
        
        Case "WAR3", "3RAW"
            BNLSProductID = &H7
        
        Case "W3XP", "PX3W"
            BNLSProductID = &H8
        
    End Select
        
End Function

Public Function BNCSProductID() As String

    Select Case UCase(Client)
    
        Case "STAR", "RATS"
            BNCSProductID = "RATS"
            
        Case "SEXP", "PXES"
            BNCSProductID = "PXES"
        
        Case "D2DV", "VD2D"
            BNCSProductID = "VD2D"
        
        Case "D2XP", "PX2D"
            BNCSProductID = "PX2D"
        
        Case "W2BN", "BN2W"
            BNCSProductID = "NB2W"
        
        Case "WAR3", "3RAW"
            BNCSProductID = "3RAW"
        
        Case "W3XP", "PX3W"
            BNCSProductID = "PX3W"
        
    End Select
    
End Function
Public Function CreateFile(file As String) As Boolean
    Dim FSO As New FileSystemObject
    If FSO.FileExists(file) = False Then
        FSO.CreateTextFile file: CreateFile = True
        
        SaveSetting "Login", "Username", "1"
        SaveSetting "Login", "Password", "1"
        SaveSetting "Login", "Home", "1"
        SaveSetting "Login", "Client", "1"
        SaveSetting "Login", "CDKey", "1"
        SaveSetting "Login", "CDKey Expansion", "1"
        SaveSetting "Login", "Server", "1"
        SaveSetting "Login", "BNLS Server", "1"
        SaveSetting "Login", "Auto Connect", "off"
        SaveSetting "Login", "E-mail", "1"
        
        SaveSetting "Bot", "Whisper responses", "off"
        SaveSetting "Bot", "Trigger", "."
        SaveSetting "Bot", "Realm", "USWest"
        
        SaveSetting "Features", "Shortvisit Ban", "off"
        SaveSetting "Features", "Shortvisit Ban Time", "2000"
        SaveSetting "Features", "Fast join talk", "off"
        SaveSetting "Features", "Fast join talk time", "1000"
        SaveSetting "Features", "Pingban", "off"
        SaveSetting "Features", "Pingban Limit", "700"
        SaveSetting "Features", "IPBan", "off"
        SaveSetting "Features", "Lockdown", "off"
        SaveSetting "Features", "Lockdown Message", "lockdown"
        SaveSetting "Features", "Spamban", "off"
        SaveSetting "Features", "Remote Channel", "off"
    End If
    
End Function
Public Function GetSetting(ByRef Section As String, ByRef key As String) As String
    Dim Buffer As String * 256

    If Profile = vbNullString Then
        If CreateFile(App.Path & "\Config.ini") = True Then Exit Function
        If GetPrivateProfileString(Section, key, vbNullString, Buffer, 256, App.Path & "\Config.ini") = 0 Then
            AddChat vbRed, "Config Error ; Section: " & Section & " - Key: " & key
            GetSetting = 1
            Exit Function
        End If
    Else
        If CreateFile(App.Path & "\Profiles\" & Profile & "\Config.ini") = True Then Exit Function
        If GetPrivateProfileString(Section, key, vbNullString, Buffer, 256, App.Path & "\Profiles\" & Profile & "\Config.ini") = 0 Then
            AddChat vbRed, "Config Error ; Profile: " & Profile & " - Section: " & Section & " - Key: " & key
            GetSetting = 1
            Exit Function
        End If
    End If
    
    If InStrB(Buffer, vbNullChar) <> 0 Then Buffer = Split(Buffer, vbNullChar)(0)
    GetSetting = Trim$(Buffer)
    
End Function

Public Sub SaveSetting(ByRef Section As String, ByRef key As String, ByRef Value As String)
    If Profile = vbNullString Then
        CreateFile App.Path & "\Config.ini"
        WritePrivateProfileString Section, key, Value, App.Path & "\Config.ini"
    Else
        CreateFile App.Path & "\Profiles\" & Profile & "\Config.ini"
        WritePrivateProfileString Section, key, Value, App.Path & "\Profiles\" & Profile & "\Config.ini"
    End If
End Sub
Public Sub AddChat(ParamArray saElements() As Variant)
Dim strTimeStamp As String
Dim Data As String
strTimeStamp = Time & " | "

If LenB(frmMain.rtbMain.Text) >= 25000 Then frmMain.rtbMain.Text = vbNullString

With frmMain.rtbMain
    .SelStart = Len(.Text)
    .SelLength = 0
    .SelColor = vbGray
    .SelText = strTimeStamp
    .SelStart = Len(.Text)
    Data = strTimeStamp
End With

Dim I As Integer
For I = LBound(saElements) To UBound(saElements) Step 2
With frmMain.rtbMain
    .SelStart = Len(.Text)
    .SelLength = 0
    .SelColor = saElements(I)
    .SelText = saElements(I + 1) & Left$(vbCrLf, -2 * CLng((I + 1) = UBound(saElements)))
    .SelStart = Len(.Text)
    Data = Data & saElements(I + 1)
End With
Next I
End Sub
Public Function Suffix(str As String, Optional Char As String = "*")
    If InStrB(str, Char) <> 0 Then
        Suffix = Mid$(str, InStrRev(str, Char) + 1)
    Else
        Suffix = str
    End If
End Function
Public Function Prefix(str As String, Optional Char As String = "*")
    If InStrB(str, Char) <> 0 Then
        Prefix = Left$(str, InStr(str, Char) - 1)
    Else
        Prefix = str
    End If
End Function
Private Function LongToUnsigned(Value As Long) As Double
    If Value < 0 Then
        LongToUnsigned = Value + 4294967296#
    Else
        LongToUnsigned = Value
    End If
End Function
Public Function Matches(ByVal strText As String, ByVal strMatch As String) As Boolean
    If Len(strText) = 0 Then Exit Function
    Call PrepareCheck(strMatch)
    Matches = (LCase$(strText) Like LCase$(strMatch))
End Function
Public Sub PrepareCheck(ByRef S As String)
    If InStrB(S, "[") <> 0 Then S = Replace$(S, "[", "")
    If InStrB(S, "]") <> 0 Then S = Replace$(S, "]", "")
    If InStrB(S, "") <> 0 Then S = Replace$(S, "", "[[]")
    If InStrB(S, "") <> 0 Then S = Replace$(S, "", "[]]")
    If InStrB(S, "#") <> 0 Then S = Replace$(S, "#", "[#]")
    If InStrB(S, "-") <> 0 Then S = Replace$(S, "-", "[-]")
End Sub
Public Sub Disconnect()
    With frmMain
        ForceReconnect = False
        BNCSConnected = False
        .sckBNCS.Close
        .sckBNLS.Close
    End With
End Sub
Public Sub Disconnected()
    With frmMain
        ForceReconnect = True
        BNCSConnected = False
        .sckBNCS.Close
        .sckBNLS.Close
        AddChat vbYellow, "Attempting to reconnect in 30 seconds.."
        StartReconnectTimer 30000
    End With
End Sub
Public Function Version() As String
Version = "version 1." & App.Minor & "." & App.Revision & ""
End Function
Public Function AddQuotes(Name As String) As String
    AddQuotes = Chr$(34) & Name & Chr$(34)
End Function
Public Function Wildcardcheck(Username As String) As Boolean
Dim I As Integer, Temp As clsDatabase
    For I = 0 To Database.Count
        Set Temp = Database.GetByIndex(I)
        If (ATTR_B And Temp.Flags) = ATTR_B Then
            If (InStrB(Temp.Username, "*")) Then
                If Matches(Username, Database.GetByIndex(I).Username) = True Then
                    If Database.Safelist(Username) = False Then
                        If (ATTR_B And Temp.Flags) = ATTR_B Then Wildcardcheck = True: Exit Function
                    End If
                End If
            End If
        End If
    Next I
End Function
Public Function DateTimeToLongString(ByRef DT As DATETIME, Optional ByVal Seconds As Boolean = True) As String
    Dim buf As String
    If (DT.Weeks) Then buf = DT.Weeks & IIf(DT.Weeks = 1, " week, ", " weeks, ")
    If (DT.Days) Then buf = buf & DT.Days & IIf(DT.Days = 1, " day, ", " days, ")
    If (DT.Hours Or DT.Days) Then buf = buf & DT.Hours & IIf(DT.Hours = 1, " hour, ", " hours, ")
    If (DT.Hours Or DT.Days Or DT.Minutes) Then buf = buf & DT.Minutes & IIf(DT.Minutes = 1, " minute, ", " minutes, ")
    If Seconds Then
        buf = buf & IIf(Len(buf) > 0, "and ", vbNullString) & DT.Seconds & IIf(DT.Seconds = 1, " second", " seconds")
    Else
        If Len(buf) = 0 Then buf = "less than a minute"
    End If
    If Right$(buf, 2) = ", " Then buf = Left$(buf, Len(buf) - 2)
    DateTimeToLongString = buf
End Function
Public Function ConvertTickCount(ByVal TickCount As Double) As DATETIME
On Error GoTo hErr
    Dim DT As DATETIME
    TickCount = TickCount / 1000
    DT.Days = Int(TickCount / 86400)
    TickCount = TickCount Mod 86400
    DT.Hours = Int(TickCount / 3600)
    TickCount = TickCount Mod 3600
    DT.Minutes = Int(TickCount / 60)
    TickCount = TickCount Mod 60
    DT.Seconds = TickCount
    DT.Weeks = DT.Days \ 7
    DT.Days = DT.Days Mod 7
    ConvertTickCount = DT
    Exit Function
hErr:
    ConvertTickCount = DT
End Function
Public Sub Connect()

        With frmMain
            .sckBNCS.Close
            .sckBNLS.Close
        End With
        
        LoadSettings
        ForceReconnect = True
        BNCSConnected = False
        frmMain.sckBNLS.Connect BNLSServer, 9367
        AddChat vbGray, "Connecting to BNLS..."
        OpsCount = 0
        
End Sub

Public Function RemoveChars(User As String) As String
    Dim Splt() As String
    Splt = Split(User, "@")
    
    RemoveChars = User
    RemoveChars = Replace(RemoveChars, ",", vbNullString)
    RemoveChars = Replace(RemoveChars, Chr(34), vbNullString)
    
    If InStrB(User, "@") <> -1 Then
        If Warcraft3 Then
            If InStrB(User, "lordaeron") Or InStrB(User, "azeroth") Then RemoveChars = Splt(0)
        Else
            If InStrB(User, "uswest") Or InStrB(User, "useast") Then RemoveChars = Splt(0)
        End If
    End If
End Function
Public Sub InitProtection(Join As Boolean, Optional Username As String)
If Lockdown = False Then Exit Sub
Dim User As clsUserInfo, I As Integer
    If Join = True Then
        If LenB(Username) = 0 Then Exit Sub
        If Database.GetByName(Username).Safelisted = False And Database.GetByName(Username).Friended = False Then
            Call AddQ("/ban " & Username & Space(1) & LockdownMessage)
        End If
    Else
        For I = 0 To Users.Count
            Set User = Users.GetByIndex(I)
            If LenB(User.Username) <> 0 Then
                If Database.GetByName(User.Username).Safelisted = False And Database.GetByName(User.Username).Friended = False Then
                    Call AddQ("/ban " & User.Username & Space(1) & LockdownMessage)
                End If
            End If
        Next I
    End If
End Sub
Public Sub CheckIgnored(Username As String)
  
If Users.GetByName(Username).IsIgnored Then
    If Database.GetByName(Username).Safelisted = True Then
        AddQ "/unignore " & Username
    End If
End If
    
End Sub
Public Function CheckOpsCount() As Boolean
Dim I As Integer, Count As Integer
Dim User As New clsUserInfo

For I = 0 To Users.Count
    Set User = Users.GetByIndex(I)
    If LenB(User.Username) = 0 Then Exit Function
    
    If User.IsOperator = True Then
        Count = Count + 1
    End If
Next I
    
If Count >= 1 Then
    CheckOpsCount = True
    Count = 0
    Exit Function
End If
End Function
Public Sub CheckBanned(Username As String)
Dim DBUIndex As Integer

DBUIndex = Banlist.Find(Username)

If DBUIndex <> -1 Then
    Banlist.Remove Username
End If
End Sub
Public Function DblTickCount() As Double
    #If Win16 Then
        DblTickCount = CDbl(GetTickCount())
    #Else
        Dim Cou As Currency
        Dim Fre As Currency
    On Error GoTo hErr
        If QueryPerformanceCounter(Cou) And QueryPerformanceFrequency(Fre) Then
            DblTickCount = Int(Cou / Fre * 1000)
        Else
            DblTickCount = LongToUnsigned(GetTickCount)
        End If
    #End If
    Exit Function
hErr:
    DblTickCount = 0
End Function

Public Function ClientToWardenInt() As Long
    Select Case UCase(Config.Client)
        Case "STAR", "RATS"
            ClientToWardenInt = 0
        Case "SEXP", "PXES"
            ClientToWardenInt = 1
        Case "D2DV", "VD2D"
            ClientToWardenInt = 3
        Case "D2XP", "PX2D"
            ClientToWardenInt = 4
        Case "W2BN", "NB2W"
            ClientToWardenInt = 2
        Case "WAR3", "3RAW"
            ClientToWardenInt = 5
        Case "W3XP", "PX3W"
            ClientToWardenInt = 6
    End Select
End Function

Public Function ByteArrayToString(ByRef bytArray() As Byte) As String
    Dim sAns As String
    
    sAns = StrConv(bytArray, vbUnicode)
    
    If Len(sAns) = 1 Then sAns = vbNullString
    If Len(sAns) > 1 Then sAns = Left(sAns, Len(sAns) - 1)
    
    ByteArrayToString = sAns
    
 
 End Function
 
 Public Function StringToByteArray(Data As String) As Byte()
 
    Dim bArray() As Byte
    
    bArray = StrConv(Data, vbFromUnicode)

    StringToByteArray = bArray
    
 End Function
